package net.antonioshome.clexec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;

/**
 * Used to send data from a InputStream to a OutputStream.
 * @author Antonio Vieiro (antonio@antonioshome.net)
 * @author $Author: $
 * @version $Revision: $
 */
class InputStream2OutputStreamPipe
  implements Runnable
{

  private InputStream input;
  private OutputStream output;
  private PrintStream stderr;

  public InputStream2OutputStreamPipe( InputStream anInputStream,
    OutputStream anOutputStream,
    PrintStream anErrorStream)
  {
    this.input = anInputStream;
    this.output = anOutputStream;
    this.stderr = anErrorStream;
  }

  public void runBuffered()
    throws InterruptedException
  {
    try
    {
      byte[] buffer = new byte[256];
      do
      {
        int nRead = input.read(buffer);
        if (nRead == -1)
          break;
        output.write(buffer, 0, nRead);
        output.flush();
      }
      while (true);
    }
    catch (IOException ioe)
    {
      ioe.printStackTrace(stderr);
    }
  }

  public void run()
  {
    try
    {
      runBuffered();
    }
    catch (InterruptedException ie)
    {
      try
      {
        output.flush();
      }
      catch (IOException ex)
      {
        // Ignored
      }
    }
  }
}
