package net.antonioshome.clexec;

import java.io.File;
import java.io.IOException;
import java.util.concurrent.Future;
import net.antonioshome.clexec.ProcessExecutor;
import net.antonioshome.clexec.ProcessStreams;

/**
 * A ProcessExecutor for Unix operating systems.
 * @author Antonio Vieiro (antonio@antonioshome.net)
 * @author $Author: $
 * @version $Revision: $
 */
class UnixCommandLineExecutor
  implements ProcessExecutor
{
  public Future<Integer> execute(ProcessStreams anInputOutput,
    File aWorkingDirectory, String aCommandLine)
    throws IOException
  {
    Process process = Runtime.getRuntime().exec( aCommandLine, null, aWorkingDirectory );

    ProcessWrapper processWrapper = new ProcessWrapper( anInputOutput, process );

    return ProcessExecutionService.getService().submit( processWrapper );
  }
  
}
